<template>
  <div>
    <v-row justify="center" no-gutters>
      <v-card style="width: 100%">
        <v-toolbar style="position: relative" color="white" elevation="0">
          <v-spacer />
          <v-toolbar-title class="mt-5">
            <span class="primary--text">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-bookshelf</v-icon
              ><b>{{ titleDialog }}</b>
            </span>
          </v-toolbar-title>
          <v-spacer />
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-icon v-on="on" style="position: absolute; right: 15px" color="red" @click="close"
                >mdi-close</v-icon
              >
            </template>
            <span><b>Fechar</b> janela</span>
          </v-tooltip>
        </v-toolbar>
        <v-card-text class="scrollForm">
          <v-container>
            <v-row v-if="!update">
              <v-select
                autofocus
                v-model="typeAdd"
                prepend-icon="mdi-format-list-bulleted-type"
                label="Tipo"
                :items="itemsAdd"
              ></v-select>
            </v-row>
            <v-row v-if="typeAdd === 'Arquivo' && !itemDaddy.id && !update">
              <v-col cols="12" sm="12" md="12">
                <v-text-field
                  v-model="supportResource.name"
                  label="Nome do Arquivo"
                  required
                  prepend-icon="mdi-pencil-box-outline"
                ></v-text-field>
              </v-col>
            </v-row>
            <v-row v-if="typeAdd === 'Arquivo' && !update">
              <v-col>
                <v-file-input
                  v-model="file"
                  dense
                  label="Selecionar arquivo"
                  accept="image/png, image/jpeg, image/bmp, application/pdf, application/xls, application/xml, application/pptx, application/ppt"
                  outlined
                  loader-height="4"
                />
              </v-col>
            </v-row>
            <v-row v-if="typeAdd === 'Pasta' || updateFolder === true">
              <v-col cols="12" sm="12" md="12">
                <v-text-field
                  v-model="folder.name"
                  label="Nome da Pasta"
                  required
                  prepend-icon="mdi-pencil-box-outline"
                ></v-text-field>
              </v-col>
            </v-row>
            <v-row v-if="typeAdd === 'Link Externo' || updateLink === true">
              <v-col cols="12" sm="12" md="12">
                <v-text-field
                  autofocus
                  v-model="externalLink.name"
                  label="Nome do link externo"
                  required
                  prepend-icon="mdi-pencil-box-outline"
                ></v-text-field>
              </v-col>
            </v-row>
            <v-row v-if="typeAdd === 'Link Externo' || updateLink === true">
              <v-col cols="12" sm="12" md="12">
                <v-text-field
                  v-model="externalLink.link"
                  label="url"
                  required
                  prepend-icon="mdi-link-box-variant-outline"
                ></v-text-field>
              </v-col>
            </v-row>
            <!-- Drive polvo -->
            <div v-if="typeAdd === 'Arquivo Drive-Polvo'">
              <v-row class="removeSelected ml-5 mb-5">
                <b>Selecionados:</b>
                <v-chip
                  v-for="item in selectedsArchive"
                  :key="item.id"
                  style="font-weight: 500"
                  class="ml-2"
                  small
                  close
                  color="#f5f5f5"
                  @click:close="removeItem(item)"
                  >{{ item.extension ? `${item.name}${item.extension}` : `${item.name}` }}</v-chip
                >
              </v-row>
              <v-row class="pl-8 mb-5">
                <span class="iconNavTitle caption font-weight-medium">Diretório Atual:</span>
                <v-chip
                  class="ml-2"
                  :style="driveNav.length == 0 ? 'font-weight: 600; color: #2a0845' : ''"
                  :color="driveNav.length == 0 ? 'test' : ''"
                  @click="navPath()"
                  label
                  small
                >
                  seu drive
                </v-chip>
                <v-chip
                  v-for="(path, index) in driveNav"
                  :key="index"
                  text
                  label
                  small
                  class="ml-1"
                  :style="index == driveNav.length - 1 && 'font-weight: 600; color: #2a0845'"
                  :color="driveNav.length - 1 === index ? 'test' : ''"
                  @click="navPath(path, index)"
                >
                  {{ path.name }}
                </v-chip>
              </v-row>
              <v-row v-if="!loading" class="mb-2" justify="center" no-gutters>
                <v-col
                  class="pl-2"
                  style="font-size: 0.8rem; font-weight: 500; display: flex; max-width: 95%"
                  cols="12"
                >
                  # Pastas/Arquivos
                  <v-spacer />
                  Selecionados
                </v-col>
              </v-row>
              <v-row v-if="archivesDrive.length == 0 && !loading" justify="center" align="center">
                Desculpe, esse diretório não contem arquivos.
              </v-row>
              <v-row align="center" justify="center" no-gutters>
                <v-col
                  v-for="item in archivesDrive"
                  :key="item.name"
                  class="hoverFile py-1 pl-2 ma-0"
                  cols="12"
                  style="position: relative; max-width: 95%"
                >
                  <v-checkbox
                    style="position: absolute; right: 0px; top: -18px"
                    v-model="item.checked"
                    color="primary"
                    class="pb-0"
                    @change="addSelected(item)"
                  ></v-checkbox>
                  <span>
                    <v-icon v-if="item.extension" class="mt-n1 mr-2">{{
                      item.extension ? `${files[item.extension.replace('.', '')]}` : 'mdi-folder'
                    }}</v-icon>
                    <v-icon v-if="item.link" class="mt-n1 mr-2">mdi-link</v-icon>
                    <v-icon v-if="!item.link && !item.extension" class="mt-n1 mr-2"
                      >mdi-folder</v-icon
                    >
                    <v-tooltip right color="transparent" nudge-left="15px">
                      <template v-slot:activator="{ on }">
                        <span
                          v-on="on"
                          :class="item.extension ? 'ma-0 pa-0' : 'clickItemDrive ma-0 pa-0'"
                          @click="refreshItems(item)"
                          >{{
                            item.extension ? `${item.name}${item.extension}` : `${item.name}`
                          }}</span
                        >
                      </template>
                      <span
                        class="secondary--text"
                        style="font-size: 0.75rem; font-weight: 500"
                        v-if="!item.extension && !item.link"
                        >(Click p/ abrir pasta)</span
                      >
                      <span class="secondary--text" style="font-size: 0.75rem" v-if="item.link">{{
                        item.link
                      }}</span>
                    </v-tooltip>
                  </span>
                </v-col>
              </v-row>
            </div>
            <!-- fim add from drive -->

            <v-text-field 
              prepend-icon="mdi-pencil-box-outline" 
              v-if="update && updateFile" 
              v-model="updateFileName" 
              label="Alterar o nome do arquivo" />

            <v-row>
              <v-spacer></v-spacer>
              <!--prettier-ignore-->
              <a
                  v-if="
                  update ||
                    typeAdd === 'Arquivo' ||
                    typeAdd === 'Link Externo' ||
                    typeAdd === 'Pasta' ||
                    typeAdd === 'Arquivo Drive-Polvo'
                "
                  @click="Advanced"
                >
                  <v-icon>mdi-cog</v-icon>Opções avançadas
                </a>
            </v-row>
            <v-row
              v-if="
                update || typeAdd === 'Arquivo' || typeAdd === 'Link Externo' || typeAdd === 'Pasta' || typeAdd === 'Arquivo'
              "
              justify="center"
            >
              <v-row v-if="showAdvanced" justify="center" class="ml-12 mt-3">
                <!--prettier-ignore-->
                <v-text-field
                    v-mask="mask"
                    label="Data para Disponibilizar"
                    prepend-icon="mdi-calendar"
                  ></v-text-field>
                <!--prettier-ignore-->
                <v-text-field
                    v-mask="mask"
                    label="Data para Finalizar"
                    prepend-icon="mdi-calendar"
                  ></v-text-field>
              </v-row>
              <v-row v-if="showAdvanced" class="mt-3" justify="center">
                <!--prettier-ignore-->
                <v-checkbox input-value="true" class="mt-5 ml-6" color="primary" label="Visivel"></v-checkbox>
              </v-row>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions class="mt-n3 pb-6 pr-6">
          <v-spacer></v-spacer>
          <v-btn color="primary" text @click="close">Cancelar</v-btn>
          <!--prettier-ignore-->
          <v-btn
              v-if="typeAdd === 'Arquivo' && childDisable === false && !update"
              color="primary"
              elevation="0"
              :disabled="!supportResource.name || !file"
              @click="fileSave"
            >{{ titleButton }}</v-btn>
          <!--prettier-ignore-->
          <v-btn
              v-if="typeAdd === 'Pasta' && childDisable === false"
              :disabled="!folder.name"
              color="primary"
              elevation="0"
              @click="folderSave"
            >{{ titleButton }}</v-btn>
          <!--prettier-ignore-->
          <v-btn
              v-if="typeAdd === 'Link Externo' && childDisable === false"
              :disabled="!externalLink.name || !externalLink.link"
              color="primary"
              elevation="0"
              @click="saveLink"
            >Adicionar</v-btn>
          <v-btn
            v-if="typeAdd === 'Arquivo Drive-Polvo' && childDisable === true"
            :disabled="selectedsArchive.length == 0"
            color="primary"
            elevation="0"
            @click="saveFromDrive"
            >Adicionar</v-btn
          >
          <!-- -- ADICIONAR DENTRO DE PASTA --- -->
          <v-btn
            v-if="childDisable && typeAdd === 'Arquivo'"
            :disabled="!file"
            color="primary"
            text
            @click="saveChild"
            >adicionar</v-btn
          >
          <v-btn
            v-if="childDisable && typeAdd === 'Pasta'"
            :disabled="!folder.name"
            color="primary"
            text
            @click="saveChild"
            >adicionar</v-btn
          >
          <!-- ---- BOTÃO EDITAR ---- -->
          
          <v-btn v-if="update" color="primary" text @click="editItem">{{ titleButton }}</v-btn>
        </v-card-actions>
      </v-card>
    </v-row>
  </div>
</template>

<script>
import Drive from '../../services/drive'
import { mask } from 'vue-the-mask'
import supportResource from '../../services/supportResource'
export default {
  name: 'AddSupport',
  directives: {
    mask,
  },
  props: {
    updateFile: {
      type: Boolean,
      default: false,
    },
    updateFolder: {
      type: Boolean,
      default: false,
    },
    updateLink: {
      type: Boolean,
      default: false,
    },
    folderDisable: {
      type: Boolean,
      default: false,
    },
    fileDisable: {
      type: Boolean,
      default: false,
    },
    dialog: {
      type: Boolean,
      default: false,
    },
    titleButton: {
      type: String,
      default: 'botao',
    },
    titleDialog: {
      type: String,
      default: 'botao',
    },
    itemFile: {
      type: Object,
      default: () => {},
    },
    itemFolder: {
      type: Object,
      default: () => {},
    },
    itemLink: {
      type: Object,
      default: () => {},
    },
    childDisable: {
      type: Boolean,
      default: false,
    },
    update: {
      type: Boolean,
      default: false,
    },
    daddy: {
      type: Object,
      default: () => {},
    },
  },
  data: () => ({
    showAdvanced: false,
    typeAdd: '',
    supportResource: {
      name: null,
      supportResourceOrFolder: 1,
    },
    folder: {
      name: null,
      supportResourceOrFolder: 2,
    },
    externalLink: {
      name: null,
      link: '',
    },
    drive: {
      archive: '',
    },
    itemsAdd: ['Arquivo', 'Pasta', 'Link Externo', 'Arquivo Drive-Polvo'],
    file: null,
    mask: '##:## - ##/##/####',
    archivesDrive: [],
    updateFileName: '',
    files: {
      html: 'mdi-language-html5',
      js: 'mdi-nodejs',
      json: 'mdi-json',
      md: 'mdi-markdown',
      pdf: 'mdi-file-pdf',
      png: 'mdi-file-image-outline',
      txt: 'mdi-file-document-outline',
      xls: 'mdi-file-excel',
      jpeg: 'mdi-file-image-outline',
      jpg: 'mdi-file-image-outline',
      gif: 'mdi-gif',
      docx: 'mdi-microsoft-word',
    },
    loading: false,
    driveNav: [],
    selectedsArchive: [],
    setIds: new Set(),
    itemDaddy: {},
  }),

  created() {
    this.supportResource = JSON.parse(JSON.stringify(this.itemFile))
    this.folder = JSON.parse(JSON.stringify(this.itemFolder))
    this.externalLink = JSON.parse(JSON.stringify(this.itemLink))
    if (this.daddy.id) {
      this.itemsAdd = ['Arquivo', 'Pasta', 'Link Externo', 'Arquivo Drive-Polvo']
    }
  },
  computed: {
    checkDialogIsActive() {
      return this.$store.state.user.closeDialog
    },
  },

  watch: {
    checkDialogIsActive() {
      if (this.checkDialogIsActive) {
        //reseta informações
        this.close()
        //por fim volta ao padrão que é false
        this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      }
    },

    itemFile() {
      this.supportResource = JSON.parse(JSON.stringify(this.itemFile))
    },
    itemFolder() {
      this.folder = JSON.parse(JSON.stringify(this.itemFolder))
    },
    itemLink() {
      this.externalLink = JSON.parse(JSON.stringify(this.itemLink))
    },
    typeAdd() {
      if (this.typeAdd === 'Arquivo Drive-Polvo') this.getFolderContent()
    },
    daddy() {
      this.itemDaddy = JSON.parse(JSON.stringify(this.daddy))
    },
    itemDaddy() {
      if (this.itemDaddy.id) {
        this.itemsAdd = ['Arquivo', 'Pasta', 'Link Externo', 'Arquivo Drive-Polvo']
      } else {
        this.itemsAdd = ['Arquivo', 'Pasta', 'Link Externo', 'Arquivo Drive-Polvo']
      }
    },
  },

  methods: {
    async getFolderContent(parentId) {
      try {
        this.loading = true
        this.$store.commit('user/UPDATE_LOADING', true)
        const ret = await Drive.readFoldercontent(parentId)
        if (ret.success) {
          this.archivesDrive = []
        }

        if (ret.data) {
          if (ret.data.folders && ret.data.files && ret.data.externalLinks) {
            this.archivesDrive = ret.data.folders
              .concat(ret.data.files)
              .concat(ret.data.externalLinks)
          }
          if (ret.data.folders && ret.data.files && !ret.data.externalLinks) {
            this.archivesDrive = ret.data.folders.concat(ret.data.files)
          }
          if (ret.data.folders && !ret.data.files && ret.data.externalLinks) {
            this.archivesDrive = ret.data.folders.concat(ret.data.externalLinks)
          }
          if (!ret.data.folders && ret.data.files && ret.data.externalLinks) {
            this.archivesDrive = ret.data.files.concat(ret.data.externalLinks)
          }
          if (ret.data.folders && !ret.data.files && !ret.data.externalLinks) {
            this.archivesDrive = ret.data.folders
          }
          if (!ret.data.folders && ret.data.files && !ret.data.externalLinks) {
            this.archivesDrive = ret.data.files
          }
          if (!ret.data.folders && !ret.data.files && ret.data.externalLinks) {
            this.archivesDrive = ret.data.externalLinks
          }

          // if (ret.data.folders && ret.data.files) {
          //   this.archivesDrive = ret.data.folders.concat(ret.data.files)
          // } else if (ret.data.folders) {
          //   this.archivesDrive = ret.data.folders
          // } else {
          //   this.archivesDrive = ret.data.files
          // }
        }

        this.archivesDrive.forEach((archive) => {
          if (this.setIds.has(archive.id)) {
            archive['checked'] = true
          }
        })
        console.log('getFolderContent -> this.archivesDrive', this.archivesDrive)
      } catch (e) {
        console.error(e)
      } finally {
        this.loading = false
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },

    async refreshItems(item) {
      console.log(item)
      if ((!item.extension && !item.link) || this.loading == true) {
        await this.getFolderContent(item.id)
        this.driveNav.push({ name: item.name, id: item.id })
      }
      if (item.link) {
        window.open(item.link, '_blank')
      }
    },

    addSelected(item) {
      if (this.setIds.has(item.id)) {
        this.selectedsArchive = this.selectedsArchive.filter((archive) => archive.id !== item.id)
        return this.setIds.delete(item.id)
      }
      this.selectedsArchive.push(item)
      this.setIds.add(item.id)
      console.log(this.setIds)
    },

    removeItem(item) {
      this.setIds.delete(item.id)
      let indexToRemove
      this.selectedsArchive.forEach((selected, index) => {
        if (selected.id == item.id) indexToRemove = index
      })
      this.selectedsArchive.splice(indexToRemove, 1)

      this.archivesDrive.forEach((removed) => {
        if (removed.id == item.id) removed.checked = false
      })
    },

    Advanced() {
      this.showAdvanced = !this.showAdvanced
    },

    close() {
      this.$emit('closeDialog')
      this.externalLink = { name: '', link: '' }
      this.typeAdd = ''
      this.file = null
      this.setIds.clear()
      this.selectedsArchive = []
    },

    fileSave() {
    this.supportResource = { ...this.supportResource, file: this.file }
      this.$emit('saveFile', this.supportResource)
      console.log(this.supportResource, "este supportResorce");
      this.typeAdd = ''
      this.file = ''
    this.supportResource = {
      name: '',
          }
  },

    folderSave() {
      this.$emit('saveFolder', this.folder)
      this.typeAdd = ''
      this.folder = {
        name: '',
      }
    },

    editItem() {
      if(this.updateFileName !== ''){  
        this.$emit('updateFileName', {
          oldName: this.itemFile.name,
          updateFileName: this.updateFileName,
          fileId: this.itemFile.file.id,
          supportResourceId: this.itemFile.id
        })
        this.updateFileName = ''
        this.$emit('init')
      } else {
        this.$emit('editItem', {
          folder: this.folder,
          file: this.supportResource,
          externalLink: this.externalLink,
        })     
      }
      this.close()

    },
    saveChild() {
      let resourceToSend
      let emitting
      if (this.typeAdd === 'Arquivo') {
        resourceToSend = this.supportResource
        emitting = 'addFileOnFolder'
      }
      if (this.typeAdd === 'Pasta') {
        console.log(this.folder, "folde");
        resourceToSend = this.folder
              emitting = 'addFolderOnFolder'
      }
      if (this.typeAdd === 'Link Externo') {
        resourceToSend = this.externalLink
        emitting = 'addExternalLink' ||'addExternalLinkOnFolder'
      }
      if (this.typeAdd === 'Arquivo Drive-Polvo') {
        resourceToSend = this.drive
        emitting = 'addDrive'
      }
      console.log( {
        daddy: this.daddy,
        file: this.file,
        supportResource: resourceToSend,
      }, "emit");
      this.$emit(emitting, {
        daddy: this.daddy,
        file: this.file,
        supportResource: resourceToSend,
      })
      this.type = ''
    },
        saveLink() {
    console.log(this.externalLink, 'external linkkkk')
      this.$emit('saveLink', this.externalLink)
    this.externalLink = {
      name: '',
      link: '',
    }
  },
    saveFromDrive() {
      this.$emit('saveFromDrive', this.selectedsArchive)
      this.selectedsArchive = []
      this.typeAdd = ''
      // this.setIds.clear()
    },
    async navPath(item, index) {
      if (!item) {
        await this.getFolderContent()
        this.driveNav = []
      } else {
        await this.getFolderContent(item.id)
        this.driveNav = this.driveNav.slice(0, index + 1)
      }
    },
  },
}
</script>
<style scoped>
.uploadInput {
  display: none;
}

.clickItemDrive {
  cursor: pointer;
}

.clickItemDrive:hover {
  cursor: pointer;
  font-weight: 500;
  color: #2a0845;
}

.hoverFile:hover {
  background: #f5f5f5;
  font-weight: 500;
  color: #2a0845;
  user-select: none;
}

.hoverFile:hover /deep/ .v-icon {
  color: #2a0845;
}

.removeSelected /deep/ .v-icon {
  color: red;
}
</style>
